const Visualize = {
  persist: false,
  stop: false,
  
  // onload window
  startUp: function() {
    Visualize.loadPref();
    var appcontent = document.getElementById("appcontent");   // browser
    if(appcontent) {
//      alert("startUp!");
      appcontent.addEventListener("DOMContentLoaded", Visualize.pageOnLoad, false);
      appcontent.addEventListener("unload", Visualize.pageUnLoad, true);
//    appcontent.addEventListener("DOMNodeRemoved", Visualize.pageUnLoad, false); // removed bad event handler usage
    }
  },
  
  loadPref: function() {
    const pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("visualize.");
    Visualize.persist = pref.getBoolPref("persist_highlights");
  },
  
  // unload window
  shutDown: function() {
    window.removeEventListener("load", Visualize.startUp, false);
    window.removeEventListener("unload", Visualize.shutDown, false);
	
    var appcontent = document.getElementById("appcontent");   // browser
    if(appcontent) {
//      alert("shutDown!");
      appcontent.removeEventListener("DOMContentLoaded", Visualize.pageOnLoad, false);
      appcontent.removeEventListener("unload", Visualize.pageUnLoad, false);
//    appcontent.removeEventListener("DOMNodeRemoved", Visualize.pageUnLoad, false); // removed bad event handler usage
    }
  },

  // onload page
  pageOnLoad: function(aEvent) {  //alert('pageOnLoad; persist=' + Visualize.persist);
	// example url:  http://this.domain.com/path/to/file.html?query=val
//    alert("doc.location.href: " + window.content.document.location.href);			// full url
//    alert("doc.location.host: " + window.content.document.location.host);			// only the domain name (this.domain.com)
//    alert("doc.location.pathname: " + window.content.document.location.pathname);	// path, after the domain name (/path/to/file.html)
											//       not including query part,  (?query=val)
    Visualize.loadPref();
    if (!Visualize.persist) return;
    var doc = aEvent.originalTarget; // doc is document that triggered "onload" event
    // get base element if it was added by us
    var base = doc.getElementById("baseper");
    var ur;
//alert("load");
    // to ensure files are loaded only once
    if (base != null) {
      ur = base.getAttribute("href");
    } else {
//      var locHost = window.content.document.location.host;
//      var locPath = window.content.document.location.pathname;
//      ur = locHost + locPath;
      ur = doc.location.href;
    }

    var fileurl = Visualize.validateFileName(ur);
//	alert('ur=' + ur);
//	alert('fileurl=' + fileurl);

    // create file path
    var file = Components.classes["@mozilla.org/file/directory_service;1"]
           .getService(Components.interfaces.nsIProperties)
           .get("ProfD", Components.interfaces.nsIFile); // get profile folder
    file.append("extensions");   // extensions sub-directory
    file.append(fileurl + '.html');   // filename
    // don't try to load a file that does not exist
    if (!file.exists()) return;
//    alert(doc.location.href == "file://"+file.path);
    // very simple alternating boolean to check if load loop is happening TODO improve this
    if (!Visualize.stop) {
      window.loadURI(file.path);
      Visualize.stop = true;
    } else {
      Visualize.stop = false;
    }
  },
  // called when highlight might have changed

  pageUnLoad: function(aEvent) {  //alert('pageUnLoad; persist=' + Visualize.persist);
    // check preferences
    Visualize.loadPref();
    if (!Visualize.persist) return;
 //   alert("you highlighted");// TODO remove later
    var doc = aEvent.originalTarget;
	//alert('doc.nodeName=' + doc.nodeName);
    if(doc.nodeName != "#document") return;// check dom is a document
    // get base element if it was added by us
	
    var base = doc.getElementById("baseper");
    var ur;
    // to ensure files are loaded only once
    if (base != null) {
      ur = base.getAttribute("href");
    } else {
//      var locHost = window.content.document.location.host;
//      var locPath = window.content.document.location.pathname;
//      ur = locHost + locPath;
      ur = doc.location.href;
      // base is to preserve relative links
      var base = doc.createElement("base");
      base.setAttribute("href",doc.location.href);
      base.setAttribute("id","baseper");
      doc.documentElement.firstChild.insertBefore(base, doc.documentElement.firstChild.firstChild);// insert of base TODO make more flexible
    }
	
    // create file path
//var fileurl = Visualize.validateFileName(locHost + locPath);
//alert('fileurl=' + fileurl);
    var fileurl = Visualize.validateFileName(ur);

    var file = Components.classes["@mozilla.org/file/directory_service;1"]
           .getService(Components.interfaces.nsIProperties)
           .get("ProfD", Components.interfaces.nsIFile); // get profile folder
    file.append("extensions");   // extensions sub-directory
    file.append(fileurl + '.html');   // filename
    //    http://developer.mozilla.org/en/docs/Parsing_and_serializing_XML#Serializing_DOM_trees_to_files
    var serializer = new XMLSerializer();
    var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
               .createInstance(Components.interfaces.nsIFileOutputStream);
    foStream.init(file, 0x02 | 0x08 | 0x20, 0666, 0);   // write, create, truncate
    serializer.serializeToStream(doc, foStream, "");   // rememeber, doc is the DOM tree
    foStream.close();
  },

  // taken from common.js of scrapbook project
  getFileName : function(aURI)
  {
    var pos, name;
    name = ( (pos = aURI.indexOf("?")) != -1 ) ? aURI.substring(0, pos) : aURI;
    name = ( (pos = name.indexOf("#")) != -1 ) ? name.substring(0, pos) : name;
    name = ( (pos = name.lastIndexOf("/")) != -1 ) ? name.substring(++pos) : name;
    return name;
  },
  // taken from common.js of scrapbook project
  validateFileName : function(aFileName)
  {
    aFileName = aFileName.replace(/[\"\?!~`]+/g, "");
    aFileName = aFileName.replace(/[\*\&]+/g, "+");
    aFileName = aFileName.replace(/[\\\/\|\:;]+/g, "-");
    aFileName = aFileName.replace(/[\<]+/g, "(");
    aFileName = aFileName.replace(/[\>]+/g, ")");
    aFileName = aFileName.replace(/[\s]+/g, "_");
    aFileName = aFileName.replace(/[%]+/g, "@");
    return aFileName;
  }
};

window.addEventListener("load", Visualize.startUp, false);
window.addEventListener("unload", Visualize.shutDown, false);
